
<!doctype html>
<html lang="es" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/logo.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.3.9">
    
    
      
        <title>Clases - Programación en Java</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.1d29e8d0.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#ef5552">
        
      
      
    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
    <script>__md_scope=new URL("../..",location),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="red" data-md-color-accent="cyan">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#clases" class="md-skip">
          Saltar a contenido
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Cabecera">
    <a href="../.." title="Programación en Java" class="md-header__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Programación en Java
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Clases
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Búsqueda" placeholder="Búsqueda" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" aria-label="Limpiar" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Inicializando búsqueda
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navegación" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Programación en Java" class="md-nav__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    Programación en Java
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Principal
      </a>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" >
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Conceptos Generales
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Conceptos Generales" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Conceptos Generales
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/lenguajes/" class="md-nav__link">
        Lenguajes de Programación
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/conceptos/" class="md-nav__link">
        Conceptos de Programación
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/disenoAlgoritmos/" class="md-nav__link">
        Diseño de Algoritmos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/EstructurasControl/" class="md-nav__link">
        Estructuras de Control
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/EstructuraPrograma/" class="md-nav__link">
        Estructura de un programa
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../conceptos/Instalaci%C3%B3n/" class="md-nav__link">
        Instalación IDE JAVA
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Estructuras de un Programa Java
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Estructuras de un Programa Java" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Estructuras de un Programa Java
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/introJava/" class="md-nav__link">
        Introducción a Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/variables/" class="md-nav__link">
        Variables
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/operadores/" class="md-nav__link">
        Asignación y Operadores Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/entradasalida/" class="md-nav__link">
        Entrada/Salida
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/control/" class="md-nav__link">
        Estructuras de Control
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/excepcion/" class="md-nav__link">
        Manejo de Excepciones
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Sintaxis
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Sintaxis" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Sintaxis
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/sintaxis/" class="md-nav__link">
        Sintaxis Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/primitivos/" class="md-nav__link">
        Tipos de Datos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/metodos/" class="md-nav__link">
        Metodos en Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/ClasesObjetos/" class="md-nav__link">
        Clases y Objetos
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Programación Orientada a Objetos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Programación Orientada a Objetos" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Programación Orientada a Objetos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../arreglos/" class="md-nav__link">
        Arreglos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../metodos/" class="md-nav__link">
        Metodos/Funciones
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../metodosEspeciales/" class="md-nav__link">
        Funciones especiales
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../container/" class="md-nav__link">
        ContainerClass
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Clases
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Clases
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#conceptos-basicos" class="md-nav__link">
    Conceptos basicos
  </a>
  
    <nav class="md-nav" aria-label="Conceptos basicos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#a-objeto" class="md-nav__link">
    a. Objeto
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#b-estado" class="md-nav__link">
    b. Estado
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#c-comportamiento" class="md-nav__link">
    c. Comportamiento
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#d-atributos" class="md-nav__link">
    d. Atributos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#e-metodos" class="md-nav__link">
    e. Métodos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#f-clase" class="md-nav__link">
    f. Clase
  </a>
  
    <nav class="md-nav" aria-label="f. Clase">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#estado-de-un-objeto-y-la-instanciacion-de-una-clase" class="md-nav__link">
    Estado de un Objeto y la instanciación de una Clase
  </a>
  
    <nav class="md-nav" aria-label="Estado de un Objeto y la instanciación de una Clase">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#ejemplo" class="md-nav__link">
    Ejemplo
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#g-encapsulamiento" class="md-nav__link">
    g. Encapsulamiento
  </a>
  
    <nav class="md-nav" aria-label="g. Encapsulamiento">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#acceso-a-los-elementos-atributos-u-operaciones-de-una-clase" class="md-nav__link">
    Acceso a los elementos (atributos u operaciones) de una clase
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#h-herencia" class="md-nav__link">
    h. Herencia
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#i-mensaje" class="md-nav__link">
    i. Mensaje
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#estructura-basica" class="md-nav__link">
    Estructura basica
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#operadores-de-clases" class="md-nav__link">
    Operadores de Clases
  </a>
  
    <nav class="md-nav" aria-label="Operadores de Clases">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#permisos" class="md-nav__link">
    Permisos
  </a>
  
    <nav class="md-nav" aria-label="Permisos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#public" class="md-nav__link">
    Public
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#protected" class="md-nav__link">
    Protected
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#sin-control-de-acceso" class="md-nav__link">
    Sin Control de Acceso
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#private" class="md-nav__link">
    Private
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#operadores-de-clases_1" class="md-nav__link">
    Operadores de Clases
  </a>
  
    <nav class="md-nav" aria-label="Operadores de Clases">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#this" class="md-nav__link">
    this
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#extend" class="md-nav__link">
    extend
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#super" class="md-nav__link">
    super
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#otros-operadores" class="md-nav__link">
    Otros Operadores
  </a>
  
    <nav class="md-nav" aria-label="Otros Operadores">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#static" class="md-nav__link">
    Static
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#final" class="md-nav__link">
    Final
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../herencia/" class="md-nav__link">
        Herencia
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../interfaces/" class="md-nav__link">
        Interfaces
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../polimorfismo/" class="md-nav__link">
        Polimorfismo
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../privacidad/" class="md-nav__link">
        Privacidad
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../persistencia/" class="md-nav__link">
        Persistencia
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../unitTest/" class="md-nav__link">
        UnitTest
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../enum/" class="md-nav__link">
        Enum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../record/" class="md-nav__link">
        Record
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Manejor de Archivos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Manejor de Archivos" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Manejor de Archivos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/txt/" class="md-nav__link">
        Archivos de texto
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/json/" class="md-nav__link">
        json
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/csv/" class="md-nav__link">
        CSV
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_7" type="checkbox" id="__nav_7" >
      
      
      
      
        <label class="md-nav__link" for="__nav_7">
          Hilos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Hilos" data-md-level="1">
        <label class="md-nav__title" for="__nav_7">
          <span class="md-nav__icon md-icon"></span>
          Hilos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../hilos/thread/" class="md-nav__link">
        Thread
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_8" type="checkbox" id="__nav_8" >
      
      
      
      
        <label class="md-nav__link" for="__nav_8">
          Diagramas UML
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Diagramas UML" data-md-level="1">
        <label class="md-nav__title" for="__nav_8">
          <span class="md-nav__icon md-icon"></span>
          Diagramas UML
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/introUML/" class="md-nav__link">
        Introducción a UML
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/clases/" class="md-nav__link">
        Diagrama de Clases
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/relaciones/" class="md-nav__link">
        Relaciones diagrama de clases
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_9" type="checkbox" id="__nav_9" >
      
      
      
      
        <label class="md-nav__link" for="__nav_9">
          Herramientas
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Herramientas" data-md-level="1">
        <label class="md-nav__title" for="__nav_9">
          <span class="md-nav__icon md-icon"></span>
          Herramientas
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/BlueJ/" class="md-nav__link">
        BlueJ
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/NetBeans/" class="md-nav__link">
        NetBeans
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/eclipse/" class="md-nav__link">
        Eclipse
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/intellij/" class="md-nav__link">
        Intellij
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/jshell/" class="md-nav__link">
        jShell
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/jupyter/" class="md-nav__link">
        Jupyter
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#conceptos-basicos" class="md-nav__link">
    Conceptos basicos
  </a>
  
    <nav class="md-nav" aria-label="Conceptos basicos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#a-objeto" class="md-nav__link">
    a. Objeto
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#b-estado" class="md-nav__link">
    b. Estado
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#c-comportamiento" class="md-nav__link">
    c. Comportamiento
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#d-atributos" class="md-nav__link">
    d. Atributos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#e-metodos" class="md-nav__link">
    e. Métodos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#f-clase" class="md-nav__link">
    f. Clase
  </a>
  
    <nav class="md-nav" aria-label="f. Clase">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#estado-de-un-objeto-y-la-instanciacion-de-una-clase" class="md-nav__link">
    Estado de un Objeto y la instanciación de una Clase
  </a>
  
    <nav class="md-nav" aria-label="Estado de un Objeto y la instanciación de una Clase">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#ejemplo" class="md-nav__link">
    Ejemplo
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#g-encapsulamiento" class="md-nav__link">
    g. Encapsulamiento
  </a>
  
    <nav class="md-nav" aria-label="g. Encapsulamiento">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#acceso-a-los-elementos-atributos-u-operaciones-de-una-clase" class="md-nav__link">
    Acceso a los elementos (atributos u operaciones) de una clase
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#h-herencia" class="md-nav__link">
    h. Herencia
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#i-mensaje" class="md-nav__link">
    i. Mensaje
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#estructura-basica" class="md-nav__link">
    Estructura basica
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#operadores-de-clases" class="md-nav__link">
    Operadores de Clases
  </a>
  
    <nav class="md-nav" aria-label="Operadores de Clases">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#permisos" class="md-nav__link">
    Permisos
  </a>
  
    <nav class="md-nav" aria-label="Permisos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#public" class="md-nav__link">
    Public
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#protected" class="md-nav__link">
    Protected
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#sin-control-de-acceso" class="md-nav__link">
    Sin Control de Acceso
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#private" class="md-nav__link">
    Private
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#operadores-de-clases_1" class="md-nav__link">
    Operadores de Clases
  </a>
  
    <nav class="md-nav" aria-label="Operadores de Clases">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#this" class="md-nav__link">
    this
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#extend" class="md-nav__link">
    extend
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#super" class="md-nav__link">
    super
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#otros-operadores" class="md-nav__link">
    Otros Operadores
  </a>
  
    <nav class="md-nav" aria-label="Otros Operadores">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#static" class="md-nav__link">
    Static
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#final" class="md-nav__link">
    Final
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content" data-md-component="content">
            <article class="md-content__inner md-typeset">
              
                


<h1 id="clases">Clases</h1>
<h2 id="conceptos-basicos">Conceptos basicos</h2>
<h3 id="a-objeto">a. Objeto</h3>
<p>El concepto básico de la POO es el de objeto, por lo tanto resulta conveniente desde ya dar una respuesta a la pregunta ¿Qué es un objeto? Inicialmente se puede decir que un objeto, según la Real Academia de la Lengua Española (RAE), es “Todo lo que puede ser materia de conocimiento o sensibilidad de parte del sujeto, incluso este mismo”. Lo anterior no está planteado desde una perspectiva computacional, pues si así fuese, podríamos decir que un objeto es:</p>
<ul>
<li>Cualquier cosa, real o abstracta, que posea un estado interno y un conjunto de operaciones o métodos.</li>
<li>Una colección de operaciones encapsuladas que comparten un estado común.</li>
</ul>
<p><img alt="objeto" src="../objeto.png" /></p>
<p>Representación de un Objeto, conteniendo su nombre, atributos y operaciones.</p>
<h3 id="b-estado">b. Estado</h3>
<p>De las definiciones técnicas anteriores, se observa un elemento común, este es el de estado, que se define como el valor de los atributos del objeto en un cierto instante.</p>
<h3 id="c-comportamiento">c. Comportamiento</h3>
<p>Se relaciona con las operaciones y como éstas hacen que se comporte el objeto ante una acción, la cual es provocada por la invocación a un método de la clase.</p>
<h3 id="d-atributos">d. Atributos</h3>
<p>Son los elementos que definen un objeto, son sus “propiedades”. Conocidas en la programación tradicional como las variables. De lo anterior podemos concluir que un atributo debe entonces definirse con un nombre que lo represente y un tipo de dato asociado.
<div class="highlight"><pre><span></span><code><a id="__codelineno-0-1" name="__codelineno-0-1" href="#__codelineno-0-1"></a><span class="kd">class</span> <span class="nc">cuentaCorriente</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-0-2" name="__codelineno-0-2" href="#__codelineno-0-2"></a><span class="w">    </span><span class="n">String</span><span class="w"> </span><span class="n">numeroCuenta</span><span class="p">;</span><span class="w">  </span><span class="c1">//Atributo de tipo String, llamado nueroCuenta</span><span class="w"></span>
<a id="__codelineno-0-3" name="__codelineno-0-3" href="#__codelineno-0-3"></a><span class="w">    </span><span class="p">....</span><span class="w"></span>
<a id="__codelineno-0-4" name="__codelineno-0-4" href="#__codelineno-0-4"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
Otro elemento a considerar además del tipo de datos y nombre de cada atributo es lo relativo a su nivel de encapsulamiento.</p>
<h3 id="e-metodos">e. Métodos</h3>
<p>También llamadas operaciones, son los que determinan aquello que se puede hacer con el objeto. Conocidos en la programación tradicional como las funciones o procedimientos. Puede entenderse como un conjunto de funciones pertenecientes a una clase, que actúan y modifican los atributos del objeto.</p>
<h3 id="f-clase">f. Clase</h3>
<p>Así como un objeto es un concepto con un grado de abstracción mayor que las comunes estructuras de datos, es posible hacer una abstracción aún mayor e introducir el concepto de Clase, entendiéndola como una descripción generalizada que hace referencia a una colección de objetos que poseen las mismas características.</p>
<h4 id="estado-de-un-objeto-y-la-instanciacion-de-una-clase">Estado de un Objeto y la instanciación de una Clase</h4>
<p>Luego, a partir de los conceptos hasta ahora mencionados, se puede decir que un objeto no es sino una instancia de una clase.</p>
<ul>
<li>Pensar en un <strong>Objeto</strong> como “caso particular” de una <strong>Clase</strong>.</li>
<li>Los atributos poseen valores específicos en un instante de tiempo, que lo identifican como un único objeto.</li>
<li>Lo anterior indica que los objetos son “dinámicos”, pues su estado puede cambiar en el tiempo.</li>
</ul>
<p>Para nuestro contexto entenderemos la <strong>abstracción</strong> como una aproximación o abordaje del diseño que hace hincapié en los aspectos más importantes de algo, sin preocuparse por los detalles menos importantes.</p>
<h5 id="ejemplo">Ejemplo</h5>
<p><img alt="objeto" src="../objetoEj.png" /></p>
<p>Abstracción de los detalles de los objetos para determinar la clase.</p>
<p><img alt="clase" src="../clase.png" /></p>
<h3 id="g-encapsulamiento">g. Encapsulamiento</h3>
<p>Esta característica fundamental de la POO permite a los objetos crear una cápsula a su alrededor, convirtiéndose en una “caja negra” para el resto de los objetos, ocultando la información interna que manipula. Lo anterior permite modificar el código interno de alguna(s) operación(es) y si lo hacemos respetando los argumentos definidos para las entradas y las salidas de dicha operación, es posible modificar y optimizarlo en forma constante, sin efectos laterales o secundarios.</p>
<p>La figura ilustra el hecho que gracias al encapsulamiento lo que se busca es proteger tanto como sea posible la integridad de los atributos del objeto y no permitir que estos puedan ser accedidos directamente. De lo anterior es que entonces se definen un conjunto de operaciones con acceso público, que permiten acceder a los atributos del objeto.</p>
<p><img alt="protected" src="../protected.png" /></p>
<p>En la figura se intenta explicar una de las ventajas del encapsulamiento, pues el código asociado a la operación Suma(n1, n2) podemos modificarlo de acuerdo a nuestras necesidades y si tenemos cuidado en respetar las entradas y salidas que esta operación usa, el resto de los objetos que usen Suma(n1, n2) no se habrán enterado (ni les interesaría hacerlo) de los cambios o mejoras que realicemos al interior de su código.</p>
<p><img alt="encapsulamiento" src="../encapsulamiento.png" /></p>
<h4 id="acceso-a-los-elementos-atributos-u-operaciones-de-una-clase">Acceso a los elementos (atributos u operaciones) de una clase</h4>
<ul>
<li>Acceso público: Cualquier miembro público de una clase es accesible desde cualquier parte donde sea accesible el propio objeto.</li>
<li>Acceso privado: Los miembros privados de una clase sólo son accesibles por los propios miembros de la clase y en general por objetos de la misma clase, pero no desde funciones externas o desde funciones de clases derivadas.</li>
<li>Acceso protegido: Con respecto a las funciones externas, es equivalente al acceso privado, pero con respecto a las clases derivadas se comporta como público.</li>
</ul>
<h3 id="h-herencia">h. Herencia</h3>
<p>Así como una clase representa genéricamente a un grupo de objetos que comparten características comunes, la herencia permite que varias clases compartan aquello que tienen en común y no repetirlo en cada clase. Consiste en propagar atributos y operaciones a través de las subclases definidas a partir de una clase común.</p>
<p>Nos permite crear estructuras jerárquicas de clases donde es posible la creación de subclases, que incluyan nuevas operaciones y atributos que redefinen los objetos. Estas subclases permiten así, crear, modificar o inhabilitar propiedades, aumentando de esta manera la especialización de la nueva clase.</p>
<p>En la figura se muestra un ejemplo del concepto de herencia, donde se tiene una clase llamada Vehículo (superclase), la cual permite representar de forma genérica a cualquier tipo de vehículo, a partir de la cual a su vez pueden originarse tipos especiales de vehículos, en este ejemplo se tienen las subclases: Sedán, Camión y Furgón, cada una de ellas con atributos y operaciones comunes, pero a la vez definen nuevos atributos u operaciones que permiten identificarlo como un tipo particular de vehículo. Entonces es posible decir que un objeto perteneciente a la clase Sedán es también un objeto de tipo Vehículo o también decir que es una especialización de la superclase, dada la relación de herencia entre ambas clases.</p>
<p><img alt="Herencia" src="../herencia.png" /></p>
<h3 id="i-mensaje">i. Mensaje</h3>
<p>Es el medio a través del cual se comunican los objetos y es la forma en que estos acceden a los servicios de otro objeto. Lo anterior implica que mediante un mensaje, un objeto le pide a otro que ejecute alguna operación que éste posee, per quien la pide no (concepto de delegación de servicios). Un objeto sólo puede mandar mensajes a aquellos objetos que lo “conocen”, estos son aquellos con los que están relacionados.</p>
<p>Para entender de mejor manera el concepto de mensaje, creemos importante que te plantees la siguiente pregunta ¿Cómo un objeto ejecuta un mensaje? Una respuesta a esta pregunta podríamos darla usando el siguiente algoritmo.
<div class="highlight"><pre><span></span><code><a id="__codelineno-1-1" name="__codelineno-1-1" href="#__codelineno-1-1"></a><span class="n">Un</span><span class="w"> </span><span class="n">objeto</span><span class="w"> </span><span class="n">recibe</span><span class="w"> </span><span class="n">un</span><span class="w"> </span><span class="n">mensaje</span><span class="p">.</span><span class="w"></span>
<a id="__codelineno-1-2" name="__codelineno-1-2" href="#__codelineno-1-2"></a><span class="n">El</span><span class="w"> </span><span class="n">objeto</span><span class="w"> </span><span class="n">busca</span><span class="w"> </span><span class="n">el</span><span class="w"> </span><span class="n">mensaje</span><span class="w"> </span><span class="n">en</span><span class="w"> </span><span class="n">su</span><span class="w"> </span><span class="n">propia</span><span class="w"> </span><span class="n">clase</span><span class="p">.</span><span class="w"></span>
<a id="__codelineno-1-3" name="__codelineno-1-3" href="#__codelineno-1-3"></a><span class="nf">Si</span><span class="w"> </span><span class="p">(</span><span class="w"> </span><span class="n">el</span><span class="w"> </span><span class="n">objeto</span><span class="w"> </span><span class="n">encuentra</span><span class="w"> </span><span class="n">el</span><span class="w"> </span><span class="n">mensaje</span><span class="w"> </span><span class="n">en</span><span class="w"> </span><span class="n">su</span><span class="w"> </span><span class="n">clase</span><span class="w"> </span><span class="p">)</span><span class="w"></span>
<a id="__codelineno-1-4" name="__codelineno-1-4" href="#__codelineno-1-4"></a><span class="w">    </span><span class="n">lo</span><span class="w"> </span><span class="n">ejecuta</span><span class="w"></span>
<a id="__codelineno-1-5" name="__codelineno-1-5" href="#__codelineno-1-5"></a><span class="n">Sino</span><span class="w"></span>
<a id="__codelineno-1-6" name="__codelineno-1-6" href="#__codelineno-1-6"></a><span class="w">    </span><span class="nf">Si</span><span class="w"> </span><span class="p">(</span><span class="w"> </span><span class="n">el</span><span class="w"> </span><span class="n">objeto</span><span class="w"> </span><span class="err">“</span><span class="n">sube</span><span class="w"> </span><span class="n">por</span><span class="w"> </span><span class="n">la</span><span class="w"> </span><span class="n">jerarquía</span><span class="w"> </span><span class="n">de</span><span class="w"> </span><span class="n">clases</span><span class="w"> </span><span class="n">a</span><span class="w"> </span><span class="n">la</span><span class="w"> </span><span class="n">que</span><span class="w"> </span><span class="n">pertenece</span><span class="err">”</span><span class="w"> </span><span class="n">y</span><span class="w"> </span><span class="n">encuentra</span><span class="w"> </span><span class="n">la</span><span class="w"> </span><span class="mi">1</span><span class="n">ª</span><span class="w"> </span><span class="n">clase</span><span class="w"></span>
<a id="__codelineno-1-7" name="__codelineno-1-7" href="#__codelineno-1-7"></a><span class="w">    </span><span class="n">que</span><span class="w"> </span><span class="n">lo</span><span class="w"> </span><span class="n">implemente</span><span class="w"> </span><span class="p">)</span><span class="w"></span>
<a id="__codelineno-1-8" name="__codelineno-1-8" href="#__codelineno-1-8"></a><span class="w">        </span><span class="n">lo</span><span class="w"> </span><span class="n">ejecuta</span><span class="w"></span>
<a id="__codelineno-1-9" name="__codelineno-1-9" href="#__codelineno-1-9"></a><span class="w">    </span><span class="n">Sino</span><span class="w"></span>
<a id="__codelineno-1-10" name="__codelineno-1-10" href="#__codelineno-1-10"></a><span class="w">        </span><span class="n">devuelve</span><span class="w"> </span><span class="n">un</span><span class="w"> </span><span class="n">error</span><span class="p">.</span><span class="w"></span>
<a id="__codelineno-1-11" name="__codelineno-1-11" href="#__codelineno-1-11"></a><span class="w">    </span><span class="n">Fin</span><span class="w"> </span><span class="n">Si</span><span class="w"></span>
<a id="__codelineno-1-12" name="__codelineno-1-12" href="#__codelineno-1-12"></a><span class="n">Fin</span><span class="w"> </span><span class="n">Si</span><span class="w"></span>
</code></pre></div>
Una representación de la interacción entre objetos a través de un mensaje se muestra en la figura, donde se puede observar como ambos objetos se encuentran relacionados. El objeto de tipo Trabajador identificado como Juan se encuentra asociado al objeto cA del tipo CajeroAutomatico. El mensaje girar dinero se observa en la flecha desde el objeto Juan, con la intención de realizar un giro hacia el objeto cA. En este caso el objeto Juan desea realizar un giro, él no sabe como, pero si sabe que el objeto cA lo puede hacer, luego el objeto Juan le hace una petición al objeto cA mediante dicho mensaje.</p>
<p><img alt="mensaje" src="../mensaje.png" />
<div class="highlight"><pre><span></span><code><a id="__codelineno-2-1" name="__codelineno-2-1" href="#__codelineno-2-1"></a><span class="kd">class</span> <span class="nc">Trabajador</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-2-2" name="__codelineno-2-2" href="#__codelineno-2-2"></a><span class="w">    </span><span class="kd">private</span><span class="w"> </span><span class="n">CajeroAutomatico</span><span class="w"> </span><span class="n">cA</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-2-3" name="__codelineno-2-3" href="#__codelineno-2-3"></a><span class="w">    </span><span class="kd">public</span><span class="w"> </span><span class="kt">void</span><span class="w"> </span><span class="nf">ejemploMensaje</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-2-4" name="__codelineno-2-4" href="#__codelineno-2-4"></a><span class="w">        </span><span class="p">...</span><span class="w"></span>
<a id="__codelineno-2-5" name="__codelineno-2-5" href="#__codelineno-2-5"></a><span class="w">        </span><span class="n">cA</span><span class="p">.</span><span class="na">girarDinero</span><span class="p">();</span><span class="w"></span>
<a id="__codelineno-2-6" name="__codelineno-2-6" href="#__codelineno-2-6"></a><span class="w">        </span><span class="p">...</span><span class="w"></span>
<a id="__codelineno-2-7" name="__codelineno-2-7" href="#__codelineno-2-7"></a><span class="w">    </span><span class="p">}</span><span class="w"></span>
<a id="__codelineno-2-8" name="__codelineno-2-8" href="#__codelineno-2-8"></a><span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<p><strong>Resumen</strong>
<img alt="resumen" src="../resumen.png" /></p>
<h2 id="estructura-basica">Estructura basica</h2>
<div class="highlight"><pre><span></span><code><a id="__codelineno-3-1" name="__codelineno-3-1" href="#__codelineno-3-1"></a><span class="c1">// Librerias</span><span class="w"></span>
<a id="__codelineno-3-2" name="__codelineno-3-2" href="#__codelineno-3-2"></a><span class="kn">import</span><span class="w"> </span><span class="nn">java.util.*</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-3" name="__codelineno-3-3" href="#__codelineno-3-3"></a><span class="kn">import</span><span class="w"> </span><span class="nn">java.awt.*</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-4" name="__codelineno-3-4" href="#__codelineno-3-4"></a>
<a id="__codelineno-3-5" name="__codelineno-3-5" href="#__codelineno-3-5"></a><span class="c1">//Declaración de clase</span><span class="w"></span>
<a id="__codelineno-3-6" name="__codelineno-3-6" href="#__codelineno-3-6"></a><span class="kd">public</span><span class="w"> </span><span class="kd">class</span> <span class="nc">Cuadrado</span><span class="w"> </span><span class="kd">extends</span><span class="w"> </span><span class="n">Rectangulo</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-3-7" name="__codelineno-3-7" href="#__codelineno-3-7"></a><span class="w">  </span><span class="c1">// variables globales o atrobutos de la clase</span><span class="w"></span>
<a id="__codelineno-3-8" name="__codelineno-3-8" href="#__codelineno-3-8"></a><span class="w">  </span><span class="kd">private</span><span class="w"> </span><span class="kt">int</span><span class="w"> </span><span class="n">lado</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-9" name="__codelineno-3-9" href="#__codelineno-3-9"></a>
<a id="__codelineno-3-10" name="__codelineno-3-10" href="#__codelineno-3-10"></a><span class="w">  </span><span class="c1">// Constructor</span><span class="w"></span>
<a id="__codelineno-3-11" name="__codelineno-3-11" href="#__codelineno-3-11"></a><span class="w">  </span><span class="kd">public</span><span class="w"> </span><span class="nf">Cuadrado</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-3-12" name="__codelineno-3-12" href="#__codelineno-3-12"></a><span class="w">    </span><span class="n">lado</span><span class="o">=</span><span class="mi">50</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-13" name="__codelineno-3-13" href="#__codelineno-3-13"></a><span class="w">    </span><span class="kd">super</span><span class="p">.</span><span class="na">changeLado1</span><span class="p">(</span><span class="n">lado</span><span class="p">);</span><span class="w"></span>
<a id="__codelineno-3-14" name="__codelineno-3-14" href="#__codelineno-3-14"></a><span class="w">    </span><span class="kd">super</span><span class="p">.</span><span class="na">changeLado2</span><span class="p">(</span><span class="n">lado</span><span class="p">);</span><span class="w"></span>
<a id="__codelineno-3-15" name="__codelineno-3-15" href="#__codelineno-3-15"></a><span class="w">  </span><span class="p">}</span><span class="w"></span>
<a id="__codelineno-3-16" name="__codelineno-3-16" href="#__codelineno-3-16"></a>
<a id="__codelineno-3-17" name="__codelineno-3-17" href="#__codelineno-3-17"></a><span class="w">  </span><span class="c1">// Metodo1</span><span class="w"></span>
<a id="__codelineno-3-18" name="__codelineno-3-18" href="#__codelineno-3-18"></a><span class="w">  </span><span class="kd">protected</span><span class="w"> </span><span class="kt">void</span><span class="w"> </span><span class="nf">suma</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-3-19" name="__codelineno-3-19" href="#__codelineno-3-19"></a><span class="w">    </span><span class="o">++</span><span class="k">this</span><span class="p">.</span><span class="na">lado</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-20" name="__codelineno-3-20" href="#__codelineno-3-20"></a><span class="w">  </span><span class="p">}</span><span class="w"></span>
<a id="__codelineno-3-21" name="__codelineno-3-21" href="#__codelineno-3-21"></a>
<a id="__codelineno-3-22" name="__codelineno-3-22" href="#__codelineno-3-22"></a><span class="w">  </span><span class="c1">// Metodo2</span><span class="w"></span>
<a id="__codelineno-3-23" name="__codelineno-3-23" href="#__codelineno-3-23"></a><span class="w">  </span><span class="kt">void</span><span class="w"> </span><span class="nf">resta</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-3-24" name="__codelineno-3-24" href="#__codelineno-3-24"></a><span class="w">    </span><span class="o">++</span><span class="k">this</span><span class="p">.</span><span class="na">lado</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-3-25" name="__codelineno-3-25" href="#__codelineno-3-25"></a><span class="w">  </span><span class="p">}</span><span class="w"></span>
<a id="__codelineno-3-26" name="__codelineno-3-26" href="#__codelineno-3-26"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h2 id="operadores-de-clases">Operadores de Clases</h2>
<h3 id="permisos">Permisos</h3>
<p>Los permisos pueden ser aplicados a clases, métodos y a atributos.</p>
<h4 id="public">Public</h4>
<p>Permite acceder desde la clase, package, subclase y el mundo.
<div class="highlight"><pre><span></span><code><a id="__codelineno-4-1" name="__codelineno-4-1" href="#__codelineno-4-1"></a><span class="kd">public</span><span class="w"> </span><span class="kd">class</span> <span class="nc">Canva</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-4-2" name="__codelineno-4-2" href="#__codelineno-4-2"></a>
<a id="__codelineno-4-3" name="__codelineno-4-3" href="#__codelineno-4-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h4 id="protected">Protected</h4>
<p>Permite acceder desde la clase, package y subclase.</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-5-1" name="__codelineno-5-1" href="#__codelineno-5-1"></a><span class="kd">protected</span><span class="w"> </span><span class="kd">class</span> <span class="nc">Canva</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-5-2" name="__codelineno-5-2" href="#__codelineno-5-2"></a>
<a id="__codelineno-5-3" name="__codelineno-5-3" href="#__codelineno-5-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h4 id="sin-control-de-acceso">Sin Control de Acceso</h4>
<p>Permite acceder desde la clase y package.</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-6-1" name="__codelineno-6-1" href="#__codelineno-6-1"></a><span class="kd">class</span> <span class="nc">Canva</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-6-2" name="__codelineno-6-2" href="#__codelineno-6-2"></a>
<a id="__codelineno-6-3" name="__codelineno-6-3" href="#__codelineno-6-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h4 id="private">Private</h4>
<p>Permite acceder solo desde la clase.
<div class="highlight"><pre><span></span><code><a id="__codelineno-7-1" name="__codelineno-7-1" href="#__codelineno-7-1"></a><span class="kd">private</span><span class="w"> </span><span class="kd">class</span> <span class="nc">Canva</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-7-2" name="__codelineno-7-2" href="#__codelineno-7-2"></a>
<a id="__codelineno-7-3" name="__codelineno-7-3" href="#__codelineno-7-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div></p>
<h3 id="operadores-de-clases_1">Operadores de Clases</h3>
<h4 id="this">this</h4>
<p>Hace referencia al objeto que se esta utilizando.</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-8-1" name="__codelineno-8-1" href="#__codelineno-8-1"></a><span class="kt">void</span><span class="w"> </span><span class="nf">resta</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-8-2" name="__codelineno-8-2" href="#__codelineno-8-2"></a><span class="w">  </span><span class="k">this</span><span class="p">.</span><span class="na">lado</span><span class="w"> </span><span class="o">-=</span><span class="w"> </span><span class="mi">10</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-8-3" name="__codelineno-8-3" href="#__codelineno-8-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h4 id="extend">extend</h4>
<p>Este operador se utiliza para señalar que la clase es “hija” de una clase. Este operador permite luego ocupar el los métodos de la clase padre a través de la operados super.</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-9-1" name="__codelineno-9-1" href="#__codelineno-9-1"></a><span class="kd">public</span><span class="w"> </span><span class="kd">class</span> <span class="nc">Cuadrado</span><span class="w"> </span><span class="kd">extends</span><span class="w"> </span><span class="n">Rectangulo</span><span class="p">{</span><span class="w"></span>
<a id="__codelineno-9-2" name="__codelineno-9-2" href="#__codelineno-9-2"></a><span class="w">  </span><span class="c1">// variables globales o atrobutos de la clase</span><span class="w"></span>
<a id="__codelineno-9-3" name="__codelineno-9-3" href="#__codelineno-9-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h4 id="super">super</h4>
<p>Este operador se utiliza para ocupar los métodos de la clase padre desde un método una clase hijo</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-10-1" name="__codelineno-10-1" href="#__codelineno-10-1"></a><span class="kd">public</span><span class="w"> </span><span class="nf">Cuadrado</span><span class="p">(){</span><span class="w"></span>
<a id="__codelineno-10-2" name="__codelineno-10-2" href="#__codelineno-10-2"></a><span class="w">  </span><span class="n">lado</span><span class="o">=</span><span class="mi">50</span><span class="p">;</span><span class="w"></span>
<a id="__codelineno-10-3" name="__codelineno-10-3" href="#__codelineno-10-3"></a><span class="w">  </span><span class="kd">super</span><span class="p">.</span><span class="na">changeLado1</span><span class="p">(</span><span class="n">lado</span><span class="p">);</span><span class="w"></span>
<a id="__codelineno-10-4" name="__codelineno-10-4" href="#__codelineno-10-4"></a><span class="w">  </span><span class="kd">super</span><span class="p">.</span><span class="na">changeLado2</span><span class="p">(</span><span class="n">lado</span><span class="p">);</span><span class="w"></span>
<a id="__codelineno-10-5" name="__codelineno-10-5" href="#__codelineno-10-5"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h3 id="otros-operadores">Otros Operadores</h3>
<p>Los permisos pueden ser aplicados a métodos y a atributos.</p>
<h4 id="static">Static</h4>
<p>Este operador aplicado a un método , permite que uno pueda acceder de forma directa a el, de modo que no es necesario crear un objeto de la clase para ocupar este método.</p>
<p>Aplicado a una variable implica que es posible acceder a esta variable desde cualquier parte de la clase y no puede existir una copia de esta a lo largo de la clase.</p>
<p>Aplicado este operador a una clase se utiliza cuando se declara para declarar una clase dentro de otra general, y que no se pueda acceder desde esa clase a otras clases del mismo grupo de clases.</p>
<div class="highlight"><pre><span></span><code><a id="__codelineno-11-1" name="__codelineno-11-1" href="#__codelineno-11-1"></a><span class="kd">public</span><span class="w"> </span><span class="kd">static</span><span class="w"> </span><span class="kt">void</span><span class="w"> </span><span class="nf">main</span><span class="p">(</span><span class="n">String</span><span class="o">[]</span><span class="w"> </span><span class="n">args</span><span class="p">){</span><span class="w"></span>
<a id="__codelineno-11-2" name="__codelineno-11-2" href="#__codelineno-11-2"></a>
<a id="__codelineno-11-3" name="__codelineno-11-3" href="#__codelineno-11-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div>
<h4 id="final">Final</h4>
<p>Este operador aplicado a una clase, evita que este este posea una Subclase</p>
<p>Este operador aplicado a un método implica que no podrá ser sobrescrito por subclases.</p>
<p>Este operador aplicado a una variable, implica que esta variable no podrá ser modificada por nadie, convirtiéndose en una constante.
<div class="highlight"><pre><span></span><code><a id="__codelineno-12-1" name="__codelineno-12-1" href="#__codelineno-12-1"></a><span class="kd">final</span><span class="w"> </span><span class="kt">int</span><span class="w"> </span><span class="nf">sumar</span><span class="p">(</span><span class="kt">int</span><span class="w"> </span><span class="n">a</span><span class="p">){</span><span class="w"></span>
<a id="__codelineno-12-2" name="__codelineno-12-2" href="#__codelineno-12-2"></a><span class="w">  </span><span class="k">return</span><span class="w"> </span><span class="p">(</span><span class="n">a</span><span class="o">+</span><span class="mi">10</span><span class="p">);</span><span class="w"></span>
<a id="__codelineno-12-3" name="__codelineno-12-3" href="#__codelineno-12-3"></a><span class="p">}</span><span class="w"></span>
</code></pre></div></p>

              
            </article>
            
  <script>var tabs=__md_get("__tabs");if(Array.isArray(tabs))e:for(var set of document.querySelectorAll(".tabbed-set")){var tab,labels=set.querySelector(".tabbed-labels");for(tab of tabs)for(var label of labels.getElementsByTagName("label"))if(label.innerText.trim()===tab){var input=document.getElementById(label.htmlFor);input.checked=!0;continue e}}</script>

          </div>
        </div>
        
      </main>
      
        <footer class="md-footer">
  
    
    <nav class="md-footer__inner md-grid" aria-label="Pie" >
      
        
        <a href="../container/" class="md-footer__link md-footer__link--prev" aria-label="Anterior: ContainerClass" rel="prev">
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
          </div>
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Anterior
              </span>
              ContainerClass
            </div>
          </div>
        </a>
      
      
        
        <a href="../herencia/" class="md-footer__link md-footer__link--next" aria-label="Siguiente: Herencia" rel="next">
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Siguiente
              </span>
              Herencia
            </div>
          </div>
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4Z"/></svg>
          </div>
        </a>
      
    </nav>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
    <div class="md-copyright__highlight">
      Copyright &copy; 2022 Francisco Escobar
    </div>
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    <script id="__config" type="application/json">{"base": "../..", "features": ["content.tabs.link"], "search": "../../assets/javascripts/workers/search.b97dbffb.min.js", "translations": {"clipboard.copied": "Copiado al portapapeles", "clipboard.copy": "Copiar al portapapeles", "search.config.lang": "es", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "B\u00fasqueda", "search.result.more.one": "1 m\u00e1s en esta p\u00e1gina", "search.result.more.other": "# m\u00e1s en esta p\u00e1gina", "search.result.none": "No se encontraron documentos", "search.result.one": "1 documento encontrado", "search.result.other": "# documentos encontrados", "search.result.placeholder": "Teclee para comenzar b\u00fasqueda", "search.result.term.missing": "Falta", "select.version.title": "Seleccionar versi\u00f3n"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.6c7ad80a.min.js"></script>
      
    
  </body>
</html>